"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const replace_evergreen_import_with_local_path_1 = require("../utils/replace-evergreen-import-with-local-path");
/**
 * Codemod to replace imports referencing a component/function/etc from evergreen-ui with the provided local path.
 *
 * This may be useful when a specific function or module is deprecated and is no longer exported - you can easily
 * vendorize the code and swap the imports to maintain the old functionality to aid in migration.
 *
 * ```
 * npx jscodeshift -t node_modules/evergreen-ui/codemods/dist/6.0.0-7.0.0/replace-imports-with-local-path.js --localPath=themes/classic-theme --importName=classicTheme --parser=tsx --extensions=js,jsx,ts,tsx fileOrDirectory --dry --print
 * ```
 */
const transformer = (file, api, options) => (0, replace_evergreen_import_with_local_path_1.replaceEvergreenImportWithLocalPath)({ file, api, localPath: options.localPath, importName: options.importName });
exports.default = transformer;
