"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getLogger = void 0;
const path_1 = __importDefault(require("path"));
/**
 * Returns a logger function that is automatically prefixed with file path info
 */
const getLogger = (file) => (message, node) => {
    var _a;
    let prefix = `${path_1.default.basename(file.path)}`;
    if (node != null) {
        prefix = `${prefix}:L${(_a = node.loc) === null || _a === void 0 ? void 0 : _a.start.line}`;
    }
    console.log(`${prefix} ${message}`);
};
exports.getLogger = getLogger;
