"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.registerExtensions = void 0;
const register_collection_extensions_1 = require("./register-collection-extensions");
const register_jsx_element_collection_extensions_1 = require("./register-jsx-element-collection-extensions");
const register_import_declaration_collection_extensions_1 = require("./register-import-declaration-collection-extensions");
const register_import_specifier_collection_extensions_1 = require("./register-import-specifier-collection-extensions");
const once_1 = require("./once");
/**
 * Utility function for registering extension methods on the JSCodeshift object, returning a typed
 * instance
 */
const _registerExtensions = (jscodeshift) => {
    const j = jscodeshift;
    (0, register_collection_extensions_1.registerCollectionExtensions)(j);
    (0, register_import_declaration_collection_extensions_1.registerImportDeclarationCollectionExtensions)(j);
    (0, register_import_specifier_collection_extensions_1.registerImportSpecifierCollectionExtensions)(j);
    (0, register_jsx_element_collection_extensions_1.registerJSXElementCollectionExtensions)(j);
    return j;
};
const registerExtensions = (0, once_1.once)(_registerExtensions);
exports.registerExtensions = registerExtensions;
