"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.registerImportSpecifierCollectionExtensions = void 0;
const once_1 = require("./once");
const _registerImportSpecifierCollectionExtensions = (jscodeshift) => {
    const j = jscodeshift;
    j.registerMethods({
        add: function (name) {
            const importSpecifiers = this;
            if (importSpecifiers.some(importSpecifier => importSpecifier.name === name)) {
                return importSpecifiers;
            }
            importSpecifiers.insertAfter(j.importSpecifier(j.identifier(name)));
            return importSpecifiers;
        },
        renameTo: function (name) {
            const importSpecifiers = this;
            importSpecifiers.forEach(importSpecifier => {
                if (importSpecifier.value.local == null) {
                    return;
                }
                importSpecifier.value.local.name = name;
            });
            return importSpecifiers;
        }
    }, j.ImportSpecifier);
    return j;
};
const registerImportSpecifierCollectionExtensions = (0, once_1.once)(_registerImportSpecifierCollectionExtensions);
exports.registerImportSpecifierCollectionExtensions = registerImportSpecifierCollectionExtensions;
